<template>
    <span class="icon icon-download" @click="downloadFile"></span>
</template>
<script lang="ts">
import { Component } from "vue-property-decorator";
import { mixins } from "vue-class-component";
import StoreModules from "@/mixins/StoreModules";
import File from "@/lib/File/File";
import CsvExporter from "@/lib/Csv/CsvExporter";
import moment from "moment";

@Component
export default class DownloadButton extends mixins(StoreModules) {
  public async downloadFile() {
    const defaultPath =
      "xand-transactions-export-asof-" +
      moment().format("YYYY-MM-DDThh-mm-ss") +
      ".csv";
    const { filePath } = await this.$remoteDialog.showSaveDialog({
      defaultPath
    });
    if (filePath) {
      const memberAddress = this.userModule.userDetails.address as string;
      const service = await this.xandModule.getMemberApiService();

      const outputFile = new File(filePath);
      const exporter = new CsvExporter(outputFile, memberAddress, service);
      await exporter.export();
    }
  }
}
</script>
<style lang="scss" scoped>
    .icon-download {
        mask: url('~@/assets/images/download_blue_24px.svg');
    }
    .icon {
        width: $defaultIconSize;
        height: $defaultIconSize;
        background: $linkBlue;
    }
    .icon:hover {
        background: $activeTransferBlue;
    }
</style>
